// Generated by dts-bundle v0.4.2

declare module 'dynamic-typed-array' {
    import { TypedArray, TypedArrayConstructor, DynamicTypedArrayOptions } from 'dynamic-typed-array/types';
    export default class DynamicTypedArray<T extends TypedArray> {
        constructor(constructor?: TypedArrayConstructor<T>, init?: number | ArrayLike<number> | Iterable<number>, {growthPolicy, allocator, deallocator, reallocator}?: DynamicTypedArrayOptions);
        size(): number;
        capacity(): number;
        get(index: number): number;
        set(index: number, value: number): void;
        push(...values: number[]): void;
        pop(): number;
        forEach(callback: (value: number, index: number) => void, thisArg?: any): void;
        [Symbol.iterator](): Iterator<number>;
        toArray(): number[];
        toJSON(): number[];
        toString(): string;
    }
}

declare module 'dynamic-typed-array/types' {
    export type GrowthPolicy = (minCapacity: number) => number;
    export type Allocator = (minByteLength: number) => ArrayBuffer;
    export type Deallocator = (buffer: ArrayBuffer) => void;
    export type Reallocator = (oldBuffer: ArrayBuffer, newByteLength: number, allocator: Allocator, deallocator: Deallocator) => ArrayBuffer;
    export type TypedArray = ArrayBufferView & ArrayLike<number>;
    export type TypedArrayConstructor<T extends TypedArray> = {
        new (buffer: ArrayBuffer, byteOffset?: number, length?: number): T;
        BYTES_PER_ELEMENT: number;
    };
    export type DynamicTypedArrayOptions = {
        growthPolicy?: GrowthPolicy;
        allocator?: Allocator;
        deallocator?: Deallocator;
        reallocator?: Reallocator;
    };
}

